﻿using System;
using System.Windows.Forms;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.DesktopEdition;

namespace LabelOverlapping
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            winformsMap1.MapUnit = GeographyUnit.DecimalDegree;
            LayerOverlay overlay = new LayerOverlay();
            overlay.Layers.Add(CreateFeatureLayer1());
            overlay.Layers.Add(CreateFeatureLayer2());
            overlay.Layers.Add(CreateFeatureLayer3());
            winformsMap1.CurrentExtent = new RectangleShape(-52.470703125, -3.6529541015625, -44.066162109375, -9.8272705078125);

            winformsMap1.Overlays.Add(overlay);
            winformsMap1.Refresh();
        }

        InMemoryFeatureLayer CreateFeatureLayer1()
        {
            Feature feature = new Feature("POINT(-48.658447265625 -6.56982421875)");
            feature.ColumnValues.Add("Name", "Featuere1");

            InMemoryFeatureLayer featureLayer = new InMemoryFeatureLayer();
            featureLayer.InternalFeatures.Add(feature);

            featureLayer.ZoomLevelSet.ZoomLevel01.DefaultPointStyle = PointStyles.Capital1;
            featureLayer.ZoomLevelSet.ZoomLevel01.DefaultTextStyle = TextStyles.Capital1("Name");
           
            featureLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

            return featureLayer;
        }

        InMemoryFeatureLayer CreateFeatureLayer2()
        {
            Feature feature = new Feature("POINT(-48.548447265625 -6.589824218125)");
            feature.ColumnValues.Add("Name", "Featuere2");

            InMemoryFeatureLayer featureLayer = new InMemoryFeatureLayer();
            featureLayer.InternalFeatures.Add(feature);

            featureLayer.ZoomLevelSet.ZoomLevel01.DefaultPointStyle = PointStyles.Capital1;
            featureLayer.ZoomLevelSet.ZoomLevel01.DefaultTextStyle = TextStyles.Capital1("Name");
            featureLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

            return featureLayer;
        }

        InMemoryFeatureLayer CreateFeatureLayer3()
        {
            Feature feature = new Feature("POINT(-48.648447265625 -6.56982421875)");
            feature.ColumnValues.Add("Name", "Featuere3");

            InMemoryFeatureLayer featureLayer = new InMemoryFeatureLayer();
            featureLayer.InternalFeatures.Add(feature);

            featureLayer.ZoomLevelSet.ZoomLevel01.DefaultPointStyle = PointStyles.Capital1;
            featureLayer.ZoomLevelSet.ZoomLevel01.DefaultTextStyle = TextStyles.Capital1("Name");
            featureLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

            return featureLayer;
        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            var chb = sender as CheckBox;
            var isChecked = chb.Checked;
            var overlay = winformsMap1.Overlays[0] as LayerOverlay;
            foreach (var layer in overlay.Layers)
            {
                var featureLayer = layer as FeatureLayer;
                featureLayer.ZoomLevelSet.ZoomLevel01.DefaultTextStyle.OverlappingRule = isChecked ? LabelOverlappingRule.NoOverlapping : LabelOverlappingRule.AllowOverlapping;
            }

            winformsMap1.Refresh();
        }
    }
}
